package IndexTemplateIdentifier::CMS;

use strict;

sub add_field {
    my ($cb, $app, $template) = @_;

    my $old = <<HERE;
      <mtapp:setting
         label="<__trans phrase="Template Type">"
         label_class="top-label"
         id="identifier"
         help_page="templates"
         help_section="template_type">
        <select name="identifier" id="identifier" tabindex="5">
          <option value="" <mt:unless name="identifier">selected="selected"</mt:unless>><__trans phrase="Custom Index Template"></option>
        <mt:loop name="index_identifiers">
          <option value="<mt:var name="key" escape="html">" <mt:if name="selected">selected="selected"</mt:if>><\$mt:var name="label" escape="html"\$> (<\$mt:var name="key" escape="html"\$>)</option>
        </mt:loop>
        </select>
      </mtapp:setting>
HERE
    $old = quotemeta($old);

    my $plugin = MT->component('IndexTemplateIdentifier');
    my $message = $plugin->translate('CustomIndexTemplateType');

    my $new = <<HERE;
      <mtapp:setting
         label="<__trans phrase="Template Type">"
         label_class="top-label"
         id="identifier"
         help_page="templates"
         help_section="template_type">
        <select name="identifier" id="identifier" tabindex="5">
          <option value="" <mt:unless name="identifier">selected="selected"</mt:unless>><__trans phrase="Custom Index Template"></option>
        <mt:loop name="index_identifiers">
          <option value="<mt:var name="key" escape="html">" <mt:if name="selected">selected="selected"</mt:if>><\$mt:var name="label" escape="html"\$> (<\$mt:var name="key" escape="html"\$>)</option>
        </mt:loop>
        </select>
      </mtapp:setting>
      <div id="identifier2_area" style="display:none">
      <mtapp:setting
         label="$message"
         label_class="top-label"
         id="identifier2">
        <input type="text" name="identifier2" id="identifier2" class="text" tabindex="8" value="<mt:var name="identifier2" escape="html">" maxlength="255" mt:watch-change="1" />
      </mtapp:setting>
      </div>
<script>
jQuery(function(){
    var identifier2;
    if ('' == jQuery('#identifier option:selected').val()) {
        jQuery('#identifier2_area').show();
    }
    jQuery('#identifier').change(function(){
        var selected = jQuery(this).val();
        if (selected == '') {
            jQuery('#identifier2_area').show();
            if (identifier2) {
                jQuery('#identifier2').val(identifier2);
            }
        } else {
            jQuery('#identifier2_area').hide();
            identifier2 = jQuery('#identifier2').val();
            jQuery('#identifier2').val('');
        }
    });
});
</script>
HERE
    $$template =~ s/$old/$new/;
}

sub cms_post_save {
    my ($eh, $app, $obj, $orig_obj) = @_;
    my $identifier = $app->param('identifier2');
    $obj->identifier($identifier) if $identifier;
    $obj->save;
}

sub template_param {
    my ($cb, $app, $param, $tmpl) = @_;

    $param->{'identifier2'} = '';
    my $id = $app->param('id');
    if ( $id ) {
        my $tmpl = MT::Template->load( $app->param('id') );
        $param->{'identifier2'} = $tmpl->identifier() if $tmpl;
    }
    1;
}

1;
